# -*- coding: utf-8 -*-
"""
Created on Mon Mar 19 16:52:33 2018

@author: florent
"""

import numpy as np
import matplotlib.pyplot as plt
import csv
import pandas
plt.rc('text', usetex=True)
plt.close('all')

df = pandas.read_csv('GeomSG6042.csv')
for x in df:
    print( x)
xxx=np.asarray(df.iloc[:,0]).astype(float)
yyy=-np.asarray(df.iloc[:,1]).astype(float)

###############################################################################
# MAIN
# rayons, calage, cordes, epaisseurs
# facteur 1000 pour la CAO mm
facteur=1000
infile='MonNom.npz'
outfile='GSD_MonNom.csv'
npzfiles=np.load(infile)
r=npzfiles['arr_0']
phi=npzfiles['arr_1']
l=npzfiles['arr_2']
nr=r.size
#gamma[0]+=5
r=r*facteur
l=l*facteur
e=np.ones(nr)*0.1

# vecteur ligne moyenne
xba=np.linspace(0.,0.03,num = 15)
xmc=np.linspace(0.031,0.2,num = 15)
xbf=np.linspace(0.21,1,num = 15)
xx=np.concatenate((xba, xmc, xbf))
npts=xx.size

# on ouvre un fichier en ecriture
with open(outfile, 'w') as csvfile:
    spamwriter = csv.writer(csvfile, delimiter='\t', lineterminator='\r')
    spamwriter.writerow(['StartLoft'])

# boucle sur les rayons
    for i in range(nr):
        spamwriter.writerow(['StartCurve'])
        xx=l[i]*(xxx*np.cos(np.deg2rad(phi[i]))+yyy*np.sin(np.deg2rad(phi[i])))
        yy=l[i]*(xxx*np.sin(np.deg2rad(phi[i]))-yyy*np.cos(np.deg2rad(phi[i])))

    # vue 2D
        plt.figure(1)
        plt.plot(xx,yy)
        plt.axis('equal')
    # Passage en cylindrique
    # projection du profil sur le moyeu
    # angles de projection
        theta=xx/r[i]
        ZZ=yy # direction axiale
        YY=r[i]*np.sin(theta) # direction tangentielle
        XX=r[i]*np.cos(theta) # direction radiale
        if i==0:
            X=XX
            Y=YY
            Z=ZZ
            X1=XX[0]
            X2=XX[-1]
            Y1=YY[0]
            Y2=YY[-1]
            Z1=ZZ[0]
            Z2=ZZ[-1]
        else:
            X=np.append(X,XX)
            Y=np.append(Y,YY)
            Z=np.append(Z,ZZ)
            X1=np.append(X1,XX[0])
            X2=np.append(X2,XX[-1])
            Y1=np.append(Y1,YY[0])
            Y2=np.append(Y2,YY[-1])
            Z1=np.append(Z1,ZZ[0])
            Z2=np.append(Z2,ZZ[-1])
   # vue a 3D
        fig = plt.figure(2)
        ax = fig.gca(projection='3d')
        ax.plot3D(XX,YY,ZZ)
        
        # export du profil courant
        for j in range(XX.size):
            spamwriter.writerow([XX[j] , YY[j] , ZZ[j]])
        spamwriter.writerow(['EndCurve'])
    spamwriter.writerow(['EndLoft'])
    spamwriter.writerow(['End'])

## Fin Vue 3D : plot des bords de fuite et bel aspect
    
ax.plot3D(X1,Y1,Z1)
ax.plot3D(X2,Y2,Z2)
ax.plot3D([r[0],r[-1]],[0,0],[0,0])
# Create cubic bounding box to simulate equal aspect ratio
max_range = np.array([X.max()-X.min(), Y.max()-Y.min(), Z.max()-Z.min()]).max()
Xb = 0.5*max_range*np.mgrid[-1:2:2,-1:2:2,-1:2:2][0].flatten() + 0.5*(X.max()+X.min())
Yb = 0.5*max_range*np.mgrid[-1:2:2,-1:2:2,-1:2:2][1].flatten() + 0.5*(Y.max()+Y.min())
Zb = 0.5*max_range*np.mgrid[-1:2:2,-1:2:2,-1:2:2][2].flatten() + 0.5*(Z.max()+Z.min())
# Comment or uncomment following both lines to test the fake bounding box:
for xb, yb, zb in zip(Xb, Yb, Zb):
   ax.plot([xb], [yb], [zb], 'w')
   
#ax.set_aspect('equal')
ax.set_xlabel('X : r')
ax.set_ylabel('Y : theta')
ax.set_zlabel('z : z')
        
